#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################
// BF -> Measure changed by Stefan due to the changes in QM
float Display::Measure(char nr, char channel, char type, char *pretext, char *unittext, char *returntext, char *qm_vertical_active, char *qm_horizontal_active)
{
	float return_val = 0;
	int ixs, ixss, cnt, zero_buf = 0, off_buf = 0;

	char buf_text[30];
	char selectedVoltage=0,selectedVoltageSecondChannel=0;
	short s_max = 0;
	short s_mdl = 0;	
	short s_min = 0;
	short s_max_raw = 0;
	short s_mdl_raw = 0;	
	short s_min_raw = 0;	
	short s_top = 0;	
	short s_base = 0;

	short s_avg = 0;
	short s_avg_cnt = 0;    	
	
	short s_sec_mdl = 0;
	short s_sec_mdl_raw = 0;	
	
	short s_thres_up_negativ_1 = 0;
	short s_thres_up_positiv_1 = 0;

	short s_thres_low_negativ_1 = 0;
	short s_thres_low_positiv_1 = 0;

	short s_thres_mdl_negativ_1 = 0;
	short s_thres_mdl_positiv_1 = 0;

	short s_thres_mdl_negativ_2 = 0;
	short s_thres_mdl_positiv_2 = 0;

	short s_thres_mdl_negativ_last = 0;
	short s_thres_mdl_positiv_last = 0;	
    	
	short s_thres_sec_mdl_negativ_1 = 0;
	short s_thres_sec_mdl_positiv_1 = 0;

	short s_thres_sec_mdl_negativ_2 = 0;
	short s_thres_sec_mdl_positiv_2 = 0;	
	
   	
	short P1 = 0;
	short P2 = 0;
	short P3 = 0;
	short PBuf = 0;
	
	if (draw_factor==0)
		return 0;
	
	ixs=MemWinStart+Trigger_Offset_Calc;//left edge in mem
	ixss=ixs+GRID_WIDTH*draw_factor;
	

	switch(QM_Second_Channel[nr])
	{
		case 1:
			selectedVoltageSecondChannel=Selected_Voltage_CH1;
			break;
		case 2:
			selectedVoltageSecondChannel=Selected_Voltage_CH2;
			break;
		case 3:
			selectedVoltageSecondChannel=Selected_Voltage_CH3;
			break;
		case 4:
			selectedVoltageSecondChannel=Selected_Voltage_CH4;
			break;
		
	}
	// Prpare for delay measurment
	if ((type == 3) || (type == 12))
	{

			s_thres_sec_mdl_negativ_1 = SIGNAL_THRES_MDL_NEGATIV_1[QM_Second_Channel[nr]];
			s_thres_sec_mdl_positiv_1 = SIGNAL_THRES_MDL_POSITIV_1[QM_Second_Channel[nr]];
			s_thres_sec_mdl_negativ_2 = SIGNAL_THRES_MDL_NEGATIV_2[QM_Second_Channel[nr]];
			s_thres_sec_mdl_positiv_2 = SIGNAL_THRES_MDL_POSITIV_2[QM_Second_Channel[nr]];
	
			s_sec_mdl = (int)((float)(SIGNAL_MDL[channel-1]-ADC_ZERO)*scale_factor[selectedVoltageSecondChannel])+GRID_HEIGHT/2;
			s_sec_mdl_raw = SIGNAL_MDL[channel-1];
	
		
	}	
		
	switch(channel)
	{
		case 1:
			selectedVoltage=Selected_Voltage_CH1;
			zero_buf=ZeroLevelCH1;
			break;
		case 2:
			selectedVoltage=Selected_Voltage_CH2;
			zero_buf=ZeroLevelCH2;
			break;
		case 3:
			selectedVoltage=Selected_Voltage_CH3;
			zero_buf=ZeroLevelCH3;
			break;
		case 4:
			selectedVoltage=Selected_Voltage_CH4;
			zero_buf=ZeroLevelCH4;
			break;
		
	}
		s_max = (int)((float)(SIGNAL_MAX[channel-1]-ADC_ZERO)*scale_factor[selectedVoltage])+GRID_HEIGHT/2;
		s_mdl = (int)((float)(SIGNAL_MDL[channel-1]-ADC_ZERO)*scale_factor[selectedVoltage])+GRID_HEIGHT/2;;
		s_min = (int)((float)(SIGNAL_MIN[channel-1]-ADC_ZERO )*scale_factor[selectedVoltage])+GRID_HEIGHT/2;
		
		s_max_raw = SIGNAL_MAX[channel-1];
		s_mdl_raw = SIGNAL_MDL[channel-1];
		s_min_raw = SIGNAL_MIN[channel-1];
		
		s_top = (int)((float)(SIGNAL_TOP[channel-1]-ADC_ZERO )*scale_factor[selectedVoltage])+GRID_HEIGHT/2;
		s_base = (int)((float)(SIGNAL_BASE[channel-1]-ADC_ZERO)*scale_factor[selectedVoltage])+GRID_HEIGHT/2;
	
		s_avg = SIGNAL_AVG[channel-1];
		s_avg_cnt = SIGNAL_AVG_CNT[channel-1];
	
		s_thres_up_negativ_1 = (SIGNAL_THRES_UP_NEGATIV_1[channel-1]-ixs)/draw_factor;
		s_thres_up_positiv_1 = (SIGNAL_THRES_UP_POSITIV_1[channel-1]-ixs)/draw_factor;
	
		s_thres_low_negativ_1 = (SIGNAL_THRES_LOW_NEGATIV_1[channel-1]-ixs)/draw_factor;
		s_thres_low_positiv_1 = (SIGNAL_THRES_LOW_POSITIV_1[channel-1]-ixs)/draw_factor;
	
		s_thres_mdl_negativ_1 = (SIGNAL_THRES_MDL_NEGATIV_1[channel-1]-ixs)/draw_factor;
		s_thres_mdl_positiv_1 = (SIGNAL_THRES_MDL_POSITIV_1[channel-1]-ixs)/draw_factor;
	
		s_thres_mdl_negativ_2 = (SIGNAL_THRES_MDL_NEGATIV_2[channel-1]-ixs)/draw_factor;
		s_thres_mdl_positiv_2 = (SIGNAL_THRES_MDL_POSITIV_2[channel-1]-ixs)/draw_factor;
	
		s_thres_mdl_negativ_last = (SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1]-ixs)/draw_factor;
		s_thres_mdl_positiv_last = (SIGNAL_THRES_MDL_POSITIV_LAST[channel-1]-ixs)/draw_factor;
	
		//printf("channel: %d, s_thres_mdl_positiv_1: %d, SIGNAL_THRES_MDL_POSITIV_1[channel-1]: %d, ixs: %d, draw_factor: %d trigger_offset: %d\n",channel,s_thres_mdl_positiv_1,SIGNAL_THRES_MDL_POSITIV_1[channel-1],ixs,draw_factor,Trigger_Offset_Calc);
/*
		case 5:
		{
		off_buf = 0;
		zero_buf = 128;
		s_max = (SIGNALM_MAX << 1) - 64 + off_buf;
		s_mdl = (SIGNALM_MDL << 1) - 64 + off_buf;
		s_min = (SIGNALM_MIN << 1) - 64 + off_buf;
		s_max_raw = SIGNALM_MAX;
		s_mdl_raw = SIGNALM_MDL;
		s_min_raw = SIGNALM_MIN;
		s_top = (SIGNALM_TOP << 1) - 64 + off_buf;
		s_base = (SIGNALM_BASE << 1) - 64 + off_buf;
	
		s_avg = SIGNALM_AVG;
		s_avg_cnt = SIGNALM_AVG_CNT;
	
		s_thres_up_negativ_1 = SIGNALM_THRES_UP_NEGATIV_1;
		s_thres_up_positiv_1 = SIGNALM_THRES_UP_POSITIV_1;
	
		s_thres_low_negativ_1 = SIGNALM_THRES_LOW_NEGATIV_1;
		s_thres_low_positiv_1 = SIGNALM_THRES_LOW_POSITIV_1;
	
		s_thres_mdl_negativ_1 = SIGNALM_THRES_MDL_NEGATIV_1;
		s_thres_mdl_positiv_1 = SIGNALM_THRES_MDL_POSITIV_1;
	
		s_thres_mdl_negativ_2 = SIGNALM_THRES_MDL_NEGATIV_2;
		s_thres_mdl_positiv_2 = SIGNALM_THRES_MDL_POSITIV_2;
	*/

	


	switch(type)
	{
		case 1:    // Average
		{
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_mdl_negativ_last;
	
		QM_Horizontal_Position_Real1 = int (float (s_avg) / float (s_avg_cnt)) + s_mdl;
	
		//return_val = MEASUREVOLTAGE(channel, (int) (zero_buf - QM_Horizontal_Position_Real1), unittext);
		return_val = MEASUREVOLTAGE(channel, (int) (zero_buf - QM_Horizontal_Position_Real1));
		sprintf(unittext, "V");
	
		qm_horizontal_active[0] = 5;
		qm_vertical_active[0] = 3;
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Average [ = "); break;
			case 2 : sprintf(pretext, "Average \\ = "); break;
			case 3 : sprintf(pretext, "Average ] = "); break;
			case 4 : sprintf(pretext, "Average ^ = "); break;
			case 5 : sprintf(pretext, "Average (M) = "); break;
		}
	
		break;
		}
		case 2:  // Delay - Done
		{
		QM_Horizontal_Position_Real1 = s_mdl;
		QM_Horizontal_Position_Real2 = s_sec_mdl;
	
		if ((QM_CHI_Edge[nr] == 1) && (QM_CHII_Edge[nr] == 1))
		{
			QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
			QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;
		}
		else if ((QM_CHI_Edge[nr] == 1) && (QM_CHII_Edge[nr] == 2))
		{
			QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
			QM_Vertical_Position_Real2 = s_thres_sec_mdl_negativ_1;
		}
		else if ((QM_CHI_Edge[nr] == 2) && (QM_CHII_Edge[nr] == 1))
		{
			QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
			QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;
		}
		else if ((QM_CHI_Edge[nr] == 2) && (QM_CHII_Edge[nr] == 2))
		{
			QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
			QM_Vertical_Position_Real2 = s_thres_sec_mdl_negativ_1;
		}
	
		//return_val = MEASURETIME(1, (int) (QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1), unittext);
		return_val = MEASURETIME(1, (int) (QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1));
		sprintf(unittext, "s");
	
		qm_horizontal_active[0] = 3;
		qm_vertical_active[0] = 3;
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Delay [ = "); break;
			case 2 : sprintf(pretext, "Delay \\ = "); break;
			case 3 : sprintf(pretext, "Delay ] = "); break;
			case 4 : sprintf(pretext, "Delay ^ = "); break;
			case 5 : sprintf(pretext, "Delay (M) = "); break;
		}
	
		break;
		}
		case 3:  // Duty Cycle - Done
		{
	
		QM_Horizontal_Position_Real1 = s_mdl;
	
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;
	
		qm_horizontal_active[0] = 5;
		qm_vertical_active[0] = 3;
	
		if (s_thres_mdl_negativ_1 > s_thres_mdl_positiv_1) return_val = (100 / (float (s_thres_mdl_positiv_2) - float (s_thres_mdl_positiv_1))) * (float (s_thres_mdl_negativ_1) - float (s_thres_mdl_positiv_1));
		else return_val = (100 / (float (s_thres_mdl_positiv_2) - float (s_thres_mdl_positiv_1))) * (float (s_thres_mdl_negativ_2) - float (s_thres_mdl_positiv_1));
	
		sprintf(unittext, "%%");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "DutyCycle [ = "); break;
			case 2 : sprintf(pretext, "DutyCycle \\ = "); break;
			case 3 : sprintf(pretext, "DutyCycle ] = "); break;
			case 4 : sprintf(pretext, "DutyCycle ^ = "); break;
			case 5 : sprintf(pretext, "DutyCycle (M) = "); break;
		}
	
		break;
		}
		case 4:  // Fall Time - Done
		{
		QM_Vertical_Position_Real1 = s_thres_up_negativ_1;
		QM_Vertical_Position_Real2 = s_thres_low_negativ_1;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(1, (int) abs(s_thres_low_negativ_1 - s_thres_up_negativ_1), unittext);
		return_val = MEASURETIME(1, (int) abs(s_thres_low_negativ_1 - s_thres_up_negativ_1));
		sprintf(unittext, "s");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "FallTime [ = "); break;
			case 2 : sprintf(pretext, "FallTime \\ = "); break;
			case 3 : sprintf(pretext, "FallTime ] = "); break;
			case 4 : sprintf(pretext, "FallTime ^ = "); break;
			case 5 : sprintf(pretext, "FallTime (M) = "); break;
		}
	
		break;
		}
		case 5:  // Frequency - Done
		{
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(2, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1), unittext);
		return_val = MEASURETIME(2, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1));
		sprintf(unittext, "Hz");
	
		//printf("schafft er nicht!\r\n");
				int temp = (int) return_val * 100;
		sprintf(buf_text, "=%d.%2d", temp/100, temp%100);
		//printf("DOCH!\r\n");
	
		if (buf_text[0] == 'I') return_val = 0.0;
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Freq [ = "); break;
			case 2 : sprintf(pretext, "Freq \\ = "); break;
			case 3 : sprintf(pretext, "Freq ] = "); break;
			case 4 : sprintf(pretext, "Freq ^ = "); break;
			case 5 : sprintf(pretext, "Freq (M) = "); break;
		}
	
		break;
		}
		case 6:   // Maximum - Done
		{
		QM_Horizontal_Position_Real1 = s_max;
		QM_Horizontal_Position_Real2 = s_min;
	
		qm_horizontal_active[0] = 5;
		qm_vertical_active[0] = 0;
	
		//return_val = MEASUREVOLTAGE(channel, (int) abs(s_max - zero_buf), unittext);
		return_val = MEASUREVOLTAGE(channel, (int) abs(s_max - zero_buf));
	
		sprintf(unittext, "V");
	
		if (s_max > zero_buf) return_val = 0 - return_val;         // Verbesserbar. - Werte direkt verarbeiten
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Max [ = "); break;
			case 2 : sprintf(pretext, "Max \\ = "); break;
			case 3 : sprintf(pretext, "Max ] = "); break;
			case 4 : sprintf(pretext, "Max ^ = "); break;
			case 5 : sprintf(pretext, "Max (M) = "); break;
		}
		break;
		}
		case 7:  // Minimum - Done
		{
		QM_Horizontal_Position_Real1 = s_max;
		QM_Horizontal_Position_Real2 = s_min;
	
		qm_horizontal_active[0] = 6;
		qm_vertical_active[0] = 0;
	
		//return_val = MEASUREVOLTAGE(channel, (int) abs(s_min - zero_buf), unittext);
		return_val = MEASUREVOLTAGE(channel, (int) abs(s_min - zero_buf));
	
		sprintf(unittext, "V");
	
		if (s_min > zero_buf) return_val = 0 - return_val;          // Verbesserbar. - Werte direkt verarbeiten
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Min [ = "); break;
			case 2 : sprintf(pretext, "Min \\ = "); break;
			case 3 : sprintf(pretext, "Min ] = "); break;
			case 4 : sprintf(pretext, "Min ^ = "); break;
			case 5 : sprintf(pretext, "Min (M) = "); break;
		}
	
		break;
		}
		case 8:   // Peak-Peak - Done
		{
		QM_Horizontal_Position_Real1 = s_max;
		QM_Horizontal_Position_Real2 = s_min;
	
		qm_horizontal_active[0] = 3;
		qm_vertical_active[0] = 0;
	
		//return_val = MEASUREVOLTAGE(channel, (int) (s_min - s_max), unittext);
		return_val = MEASUREVOLTAGE(channel, (int) (s_min - s_max));
		sprintf(unittext, "V");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Pk-Pk [ = "); break;
			case 2 : sprintf(pretext, "Pk-Pk \\ = "); break;
			case 3 : sprintf(pretext, "Pk-Pk ] = "); break;
			case 4 : sprintf(pretext, "Pk-Pk ^ = "); break;
			case 5 : sprintf(pretext, "Pk-Pk (M) = "); break;
		}
	
		break;
		}
		case 9:   // Period - Done
		{
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(1, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1), unittext);
		return_val = MEASURETIME(1, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1));
		sprintf(unittext, "s");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Period [ = "); break;
			case 2 : sprintf(pretext, "Period \\ = "); break;
			case 3 : sprintf(pretext, "Period ] = "); break;
			case 4 : sprintf(pretext, "Period ^ = "); break;
			case 5 : sprintf(pretext, "Period (M) = "); break;
		}
	
		break;
		}
		case 10:  // Phase - Done
		{
		QM_Horizontal_Position_Real1 = s_mdl;
		QM_Horizontal_Position_Real2 = s_sec_mdl;
	
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;
	
		return_val = ((float) (s_thres_sec_mdl_positiv_1 - s_thres_mdl_positiv_1) / (float) (s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1)) * 360;
	
		qm_horizontal_active[0] = 3;
		qm_vertical_active[0] = 3;
	
		sprintf(unittext, "Deg");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "Phase [ = "); break;
			case 2 : sprintf(pretext, "Phase \\ = "); break;
			case 3 : sprintf(pretext, "Phase ] = "); break;
			case 4 : sprintf(pretext, "Phase ^ = "); break;
			case 5 : sprintf(pretext, "Phase (M) = "); break;
		}
	
		break;
		}
		case 11:  // Rise Time - Done
		{
		QM_Vertical_Position_Real1 = s_thres_low_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_up_positiv_1;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(1, (int) abs(s_thres_up_positiv_1 - s_thres_low_positiv_1), unittext);
		return_val = MEASURETIME(1, (int) abs(s_thres_up_positiv_1 - s_thres_low_positiv_1));
		sprintf(unittext, "s");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "RiseTime [ = "); break;
			case 2 : sprintf(pretext, "RiseTime \\ = "); break;
			case 3 : sprintf(pretext, "RiseTime ] = "); break;
			case 4 : sprintf(pretext, "RiseTime ^ = "); break;
			case 5 : sprintf(pretext, "RiseTime (M) = "); break;
		}
	
		break;
		}
		case 12:  // RMS
		{
		///QM_Horizontal_Position_Real1 = zero_buf - (int (float (zero_buf - s_max) / 1.414));
		QM_Horizontal_Position_Real1 = (int (float (zero_buf - s_max) / 1.414));
	
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		QM_Vertical_Position_Real2 = s_thres_mdl_positiv_last;
	
		qm_horizontal_active[0] = 5;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1 - zero_buf), unittext);
		///return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1 - zero_buf));
		return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1));
		sprintf(unittext, "V");
	
		if (QM_Horizontal_Position_Real1 > zero_buf) return_val = 0 - return_val;         // Verbesserbar. - Werte direkt verarbeiten
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "RMS [ = "); break;
			case 2 : sprintf(pretext, "RMS \\ = "); break;
			case 3 : sprintf(pretext, "RMS ] = "); break;
			case 4 : sprintf(pretext, "RMS ^ = "); break;
			case 5 : sprintf(pretext, "RMS (M) = "); break;
		}
	
		break;
		}
		case 13:  // + Width - Done
		{
		QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
		if (s_thres_mdl_positiv_1 < s_thres_mdl_negativ_1) QM_Vertical_Position_Real2 = s_thres_mdl_negativ_1;
		else QM_Vertical_Position_Real2 = s_thres_mdl_negativ_2;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - s_thres_mdl_positiv_1), unittext);
		return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - s_thres_mdl_positiv_1));
		sprintf(unittext, "s");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "+Width [ = "); break;
			case 2 : sprintf(pretext, "+Width \\ = "); break;
			case 3 : sprintf(pretext, "+Width ] = "); break;
			case 4 : sprintf(pretext, "+Width ^ = "); break;
			case 5 : sprintf(pretext, "+Width (M) = "); break;
		}
	
		break;
		}
		case 14:  // - Width - Done
		{
		QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
		if (s_thres_mdl_negativ_1 < s_thres_mdl_positiv_1) QM_Vertical_Position_Real2 = s_thres_mdl_positiv_1;
		else QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;
	
		qm_horizontal_active[0] = 0;
		qm_vertical_active[0] = 3;
	
		//return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1), unittext);
		return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1));
		sprintf(unittext, "s");
	
		switch(channel)
		{
			case 1 : sprintf(pretext, "-Width [ = "); break;
			case 2 : sprintf(pretext, "-Width \\ = "); break;
			case 3 : sprintf(pretext, "-Width ] = "); break;
			case 4 : sprintf(pretext, "-Width ^ = "); break;
			case 5 : sprintf(pretext, "-Width (M) = "); break;
		}
		break;
		}
	}
	return return_val;
}
//##########################################################################################################################################################

//float Display::MEASUREVOLTAGE(char channel, int points, char *UnitString)			// Calculate the Voltage String
float Display::MEASUREVOLTAGE(char channel, int points)						// Calculate the Voltage String
{
	short *fprobe = 0;
	short *funits = 0;	
	volatile char *fselected_voltage = 0;	
	
	char dim = 2;
	
	int cmpvar = 0;
	
	float sfactor = 0;
	float ffactor = 0;	
	float result = 0;	
	
	float floattempad;
	int inttempbd;
	int inttempad;
			
	int xe;
	
printf("Display::MEASUREVOLTAGE(char channel, int points)\r\n");

	switch (channel)
	{
		case 1:
		{
			fprobe = &MenuStatus[1][3];
			fselected_voltage = &Selected_Voltage_CH1;
			break;
		}	
		case 2:
		{
			fprobe = &MenuStatus[2][3];
			fselected_voltage = &Selected_Voltage_CH2;
			break;
		}
		case 3:
		{
			fprobe = &MenuStatus[3][3];
			fselected_voltage = &Selected_Voltage_CH3;
			break;
		}
		case 4:
		{
			fprobe = &MenuStatus[4][3];
			fselected_voltage = &Selected_Voltage_CH4;
			break;
		}		
		case 5:
		{
            		// Solange noch kein multiplizieren Channel 1 dominant
			fprobe = (short *) 104;
			if (MenuStatus[26][2] == 1) fselected_voltage = (volatile char *) math_mul_scale - 166;
			if (MenuStatus[26][3] == 1) fselected_voltage = (volatile char *) math_sub_scale - 150;
			if (MenuStatus[26][4] == 1) fselected_voltage = (volatile char *) math_add_scale - 150;
			break;
		}		
	}

	switch ((int) *fselected_voltage)
	{
		case 0:
		{
			sfactor = 0.001;
			break;
		}
		case 1:
		{
			sfactor = 0.002;
			break;
		}
		case 2:
		{
			sfactor = 0.005;
			break;
		}
		case 3:
		{
			sfactor = 0.01;
			break;
		}
		case 4:
		{
			sfactor = 0.02;
			break;
		}
		case 5:
		{
			sfactor = 0.05;
			break;
		}
		case 6:
		{
			sfactor = 0.1;
			break;
		}
		case 7:
		{
			sfactor = 0.2;
			break;
		}
		case 8:
		{
			sfactor = 0.5;
			break;
		}
		case 9:
		{
			sfactor = 1;
			break;
		}
		case 10:
		{
			sfactor = 2;
			break;
		}
		case 11:
		{
			sfactor = 5;
			break;
		}	             		
		case 12:
		{
			sfactor = 10;
			break;
		}
		case 13:
		{
			sfactor = 20;
			break;
		}
		case 14:
		{
			sfactor = 50;
			break;
		}
		case 15:
		{
			sfactor = 100;
			break;
		}                        		
	}
	
	switch ((int) *fprobe)
	{
		case 101:
		{
			ffactor = 0.1;
			break;
		}
		case 102:
		{
			ffactor = 0.2;
			break;
		}
		case 103:
		{
			ffactor = 0.5;
			break;
		}
		case 104:
		{
			ffactor = 1;
			break;
		}
		case 105:
		{
			ffactor = 2;
			break;
		}
		case 106:
		{
			ffactor = 5;
			break;
		}
		case 107:
		{
			ffactor = 10;
			break;
		}
		case 108:
		{
			ffactor = 20;
			break;
		}
		case 109:
		{
			ffactor = 50;
			break;
		}
		case 110:
		{
			ffactor = 100;
			break;
		}
		case 111:
		{
			ffactor = 200;
			break;
		}
		case 112:
		{
			ffactor = 500;
			break;
		}
		case 113:
		{
			ffactor = 1000;
			break;
		}
	}

	result = ((sfactor * ffactor) / 48) * points;	
	/*	
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result > 999)
	{
		result = result / 1000;
		dim++;
	}
	
	switch(dim)
	{
	   case 0 : sprintf(UnitString, "&V"); break;
	   case 1 : sprintf(UnitString, "mV"); break;
	   case 2 : sprintf(UnitString, "V"); break;
	   case 3 : sprintf(UnitString, "kV"); break;
    }
    */
    //sprintf(UnitString, "V");

#ifdef _Debug_QM_
    printf("MV dim %d  %s\n", dim, UnitString);
#endif

    return result;	
}
//##########################################################################################################################################################

float Display::MEASURETIME(char sec_hz, int points)
{
	int time = 0;
	
	float tfactor = 0;
	float timeoff = 0;

	char dim = 3;
		
	tfactor = TimeBaseFactor[Display_Timebase] / 1000000;
	
	//tfactor = tfactor / 1000000 / ZFT_float;
	
	timeoff = (float)(points) * tfactor;
	
	if (sec_hz == 1)
	{   /*
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        	
        switch(dim)
        {
            case 0 : sprintf(UnitString, "ns"); break;
            case 1 : sprintf(UnitString, "&s"); break;
            case 2 : sprintf(UnitString, "ms"); break;
            case 3 : sprintf(UnitString, "s"); break;
        }	
        */
        //sprintf(UnitString, "s");

#ifdef _Debug_QM_
        printf("MT1 dim %d  %s\n", dim, UnitString);
#endif
    }
    else
	{
        timeoff = 1 / timeoff;
         /*
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }	
	    */    /*
        switch(dim)
        {
            case 0 : sprintf(UnitString, "GHz"); break;
            case 1 : sprintf(UnitString, "MHz"); break;
            case 2 : sprintf(UnitString, "kHz"); break;
            case 3 : sprintf(UnitString, "Hz"); break;
        }   */
        //sprintf(UnitString, "Hz");

#ifdef _Debug_QM_
        printf("MT2 dim %d  %s\n", dim, UnitString);	
#endif
    }

    return timeoff;
}
//##########################################################################################################################################################

void Display::CALCTRIGGER(void)
{
	int volt = 0;		
	int voltmfactor = 0;
	
	int tpos = 0;
	double vfactor = 0;	
	double vfactor2 = 0;	
	float voltoff = 0;
			
	switch(Selected_Trigger_Source)
	{
		case 1:
		{				
			volt = Selected_Voltage_CH1;
			voltmfactor = MenuStatus[1][3];
			tpos = ZeroLevelCH1 - Trigger_Pos_CH1;
			break;
		}
		case 2:
		{				
			volt = Selected_Voltage_CH2;
			voltmfactor = MenuStatus[2][3];
			tpos = ZeroLevelCH2 - Trigger_Pos_CH2;
			break;
		}
		case 3:
		{				
			volt = Selected_Voltage_CH3;
			voltmfactor = MenuStatus[3][3];
			tpos = ZeroLevelCH3 - Trigger_Pos_CH3;
			break;
		}
		case 4:
		{				
			volt = Selected_Voltage_CH4;
			voltmfactor = MenuStatus[4][3];
			tpos = ZeroLevelCH4 - Trigger_Pos_CH4;
			break;
		}
		case 5:
		{				
			volt = 7;
			voltmfactor = MenuStatus[12][4];
			tpos = Trigger_Pos_CHE - 15;
			break;
		}		
	}
	
	
	if (Selected_Trigger_Source == 5)
	{		
		switch(voltmfactor)
		{
			case 101: vfactor2 = 0.1; break;	
			case 102: vfactor2 = 0.2; break;
			case 103: vfactor2 = 0.5; break;
			case 104: vfactor2 = 1; break;
			case 105: vfactor2 = 2; break;
			case 106: vfactor2 = 5; break;
			case 107: vfactor2 = 10; break;
			case 108: vfactor2 = 20; break;
			case 109: vfactor2 = 50; break;
			case 110: vfactor2 = 100; break;
			case 111: vfactor2 = 200; break;
			case 112: vfactor2 = 500; break;
			case 113: vfactor2 = 1000; break;
		}
		
		voltoff = Extern_Trigger_Strs[Trigger_Pos_CHE] * vfactor2;
		
        Trigger_ExtLevel_Str.Write_Value(voltoff);	
        Trigger_ExtLevel_Str.RenderText();			
    }
    else
    {	  	
	
        if ((Selected_Trigger_Source != ct_Selected_Trigger_Source_buf) || (volt != ct_volt_buf) || (voltmfactor != ct_voltmfactor_buf))
        {	
            // Start calculate horizontal Data
				
            switch(volt)
            {
                case 0 : vfactor = 20.833333; break;
                case 1 : vfactor = 41.666666; break;
                case 2 : vfactor = 104.166666; break;
                case 3 : vfactor = 208.333333; break;
                case 4 : vfactor = 416.666666; break;
                case 5 : vfactor = 1041.666666; break;
                case 6 : vfactor = 2083.333333; break;
                case 7 : vfactor = 4166.666666; break;
                case 8 : vfactor = 10416.66666; break;
                case 9 : vfactor = 20833.33333; break;
                case 10 : vfactor = 41666.66666; break;
                case 11 : vfactor = 104166.6666; break;
            }
		
            vfactor = vfactor / 1000000;
		
            switch(voltmfactor)
            {
                case 101: vfactor2 = 0.1; break;	
                case 102: vfactor2 = 0.2; break;
                case 103: vfactor2 = 0.5; break;
                case 104: vfactor2 = 1; break;
                case 105: vfactor2 = 2; break;
                case 106: vfactor2 = 5; break;
                case 107: vfactor2 = 10; break;
                case 108: vfactor2 = 20; break;
                case 109: vfactor2 = 50; break;
                case 110: vfactor2 = 100; break;
                case 111: vfactor2 = 200; break;
                case 112: vfactor2 = 500; break;
                case 113: vfactor2 = 1000; break;
            }	
		
            ct_Selected_Trigger_Source_buf = Selected_Trigger_Source;
            ct_volt_buf = volt;
            ct_voltmfactor_buf = voltmfactor;
            ct_vfactor_buf = vfactor;
            ct_vfactor2_buf = vfactor2;			
        }
        else
        {
            vfactor = ct_vfactor_buf;
            vfactor2 = ct_vfactor2_buf;
        }

        voltoff = (float)(tpos) * vfactor;
        voltoff = voltoff * vfactor2;

        Trigger_Level_Str.Write_Value(voltoff);	
        Trigger_Level_Str.RenderText();	
    }	
}
//##########################################################################################################################################################
// BF fixed wrong pre trigger calculation. Calculation and timebase table changed.
// BF -> changed to indexed array fetch!!
void Display::CALCPRETRIGGER(void)
{
	float timeoff = 0;

	//timeoff = (float)(Trig_Pos_Mem - MemStartOffs) / SampleRate[Selected_Timebase];
	timeoff = (float)(Trig_Pos_Mem - MemStartOffs) / SampleRate[Display_Timebase];
	Trigger_Offset_Str.Write_Value(timeoff);
	Trigger_Offset_Str.RenderText();

}
//##########################################################################################################################################################
// BF -> changed to indexed array fetch!!
/* -> not used
void Display::CALCTIMEBASE(void)
{
	int time = 0;
	
	float tfactor = 0;
	float timeoff = 0;
		
	tfactor = TimeBaseFactor[Display_Timebase] / 1000000;
	
	timeoff = (float)(Timebase_Offset_Pos) * tfactor;  // Mitte ist 300
	
	Timebase_Offset_Str.Write_Value(timeoff);
	Timebase_Offset_Str.RenderText();
//BFTEST
/*
	printf("******************************************************************\r\n");
	printf("calculating timebase...\r\n");
	printf("timeoff = Timebase_Offset_Pos * tfactor  / 1000000\r\n\r\n");
	
	printf("Timeoffset          = "); floatprintf(timeoff); printf("\r\n");
	printf("Timebase_Offset_Pos = %d\r\n",Timebase_Offset_Pos);
	printf("tfactor             = "); floatprintf(tfactor); printf("\r\n");
	printf("******************************************************************\r\n");
*/
//}

//##########################################################################################################################################################

void Display::CALCVOLTAGE(char channel, char *String)				// Calculate the Voltage String
{
	short fprobe = 0;
	char fselected_voltage = 0;	
	
	char dim = 2;
	
	int cmpvar = 0;
	
	float sfactor = 0;
	float ffactor = 0;	
	float result = 0;	
	
	float floattempad;
	int inttempbd;
	int inttempad;
	
	char DimString[4];
		
	int xe;
	

	//BF set log dimension
	if (FFT_Mode == FFT_PWSP || FFT_Mode == FFT_PWDN)
	{
		sprintf(String, "10dBm/");
		return;
	}	


	switch (channel)
	{
		case 1:
		{
			fprobe = MenuStatus[1][3];
			fselected_voltage = Selected_Voltage_CH1;
			break;
		}	
		case 2:
		{
			fprobe = MenuStatus[2][3];
			fselected_voltage = Selected_Voltage_CH2;
			break;
		}
		case 3:
		{
			fprobe = MenuStatus[3][3];
			fselected_voltage = Selected_Voltage_CH3;
			break;
		}
		case 4:
		{
			fprobe = MenuStatus[4][3];
			fselected_voltage = Selected_Voltage_CH4;
			break;
		}
	}

	switch (fselected_voltage)
	{
		case 0:
		{
			sfactor = 0.001;
			break;
		}
		case 1:
		{
			sfactor = 0.002;
			break;
		}
		case 2:
		{	
			sfactor = 0.005;
			break;
		}
		case 3:
		{
			sfactor = 0.01;
			break;
		}
		case 4:
		{
			sfactor = 0.02;
			break;
		}
		case 5:
		{	
			sfactor = 0.05;
			break;
		}
		case 6:
		{
			sfactor = 0.1;
			break;
		}
		case 7:
		{
			sfactor = 0.2;
			break;
		}
		case 8:
		{
			sfactor = 0.5;
			break;
		}
		case 9:
		{
			sfactor = 1;
			break;
		}
		case 10:
		{
			sfactor = 2;
			break;
		}
		case 11:
		{
			sfactor = 5;
			break;
		}	
	}
	
	switch (fprobe)
	{
		case 101:
		{
			ffactor = 0.1;
			break;
		}
		case 102:
		{
			ffactor = 0.2;
			break;
		}
		case 103:
		{
			ffactor = 0.5;
			break;
		}
		case 104:
		{
			ffactor = 1;
			break;
		}
		case 105:
		{
			ffactor = 2;
			break;
		}
		case 106:
		{
			ffactor = 5;
			break;
		}
		case 107:
		{
			ffactor = 10;
			break;
		}
		case 108:
		{
			ffactor = 20;
			break;
		}
		case 109:
		{
			ffactor = 50;
			break;
		}
		case 110:
		{
			ffactor = 100;
			break;
		}
		case 111:
		{
			ffactor = 200;
			break;
		}
		case 112:
		{
			ffactor = 500;
			break;
		}
		case 113:
		{
			ffactor = 1000;
			break;
		}
	}

	if(FFT_Mode != FFT_OFF )
	sfactor /= 2;

	result = sfactor * ffactor;	
		
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result > 500)
	{
		result = result / 1000;
		dim++;
	}

	//sprintf(DimString, "");
	for (xe = 0; xe < 3; xe++)
	{
		DimString[xe] = VoltageData[dim][xe];
	}
	DimString[3] = 0;	
	
	// Copy Float to Integer
	cmpvar = (int) result;
	
#ifdef _Debug_	
//	printf("Res %f cmpvar %f\n", result, (float) cmpvar);
#endif		
	// Compare if there is a after Dot integer
	if ((float) cmpvar == result)
    	{
        	sprintf(String, "%3d %s", cmpvar, DimString);
    	}
  /*
	else if ((((float) cmpvar + 0) - result) < 0.0001)
    {
        sprintf(String, "%3d %s", cmpvar + 0, DimString);
        printf("S2\n");
    }    */
	else
	{
		inttempbd = (int) result;
		floattempad = result - (float) inttempbd;
		
		inttempad = (int) (floattempad * (float) 10);
		
		if (inttempad == 9)
        {
            inttempad = 0;
            inttempbd++;
        }
		
		sprintf(String, "%3d.%1d %s", inttempbd, inttempad, DimString);
#ifdef _Debug_		
//		printf("Res %f inttempbd %d  inttempad %d\n", result, inttempbd, inttempad);
#endif		
	}	
}
//##########################################################################################################################################################
// BF removed lot of useless coding
void Display::DRAWSIGNS(void)
{
//	long Adr_Front_Old_1, Adr_Front_Old_2, Adr_Front_New_1, Adr_Front_New_2, Adr_Front_Old_3, Adr_Front_Old_4, Adr_Front_New_3, Adr_Front_New_4;
//	long Adr_Back_Old_1, Adr_Back_Old_2, Adr_Back_New_1, Adr_Back_New_2, Adr_Back_Old_3, Adr_Back_Old_4, Adr_Back_New_3, Adr_Back_New_4;
	long Adr_Front_New_1, Adr_Front_New_2, Adr_Front_New_3, Adr_Front_New_4;
	long Adr_Back_New_1, Adr_Back_New_2, Adr_Back_New_3, Adr_Back_New_4;
	unsigned char *signbuff = 0;

 
/* BF removed because of redundance
	if (MenuStatus[1][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) + 13) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + ((Trigger_Pos_CH1_Old + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + ((Trigger_Pos_CH1_Old + 13) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
BF end	*/
        
	// for delayed mode	//BF?????
/*BF test
        if (MenuStatus[1][2] == 241)	//Inverted Signal	BF
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 206) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 206) * 80);
        }
*/
/*BF test
        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSign(Adr_Front_Old_3);
        RemoveZeroSign(Adr_Front_Old_4);
*/

    //}

/*BF test
    // Remove Channel 1 Zero
    if (XY_Mode)	//Check XY-Mode
    {
        //DrawZeroSignXY(ZeroLevelCH1_Old, 0);
    }
    else
    {
        Adr_Front_Old_1 = v_Channel_Plane1 + ((ZeroLevelCH1_Old + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + ((ZeroLevelCH1_Old + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + ((ZeroLevelCH1_Old + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + ((ZeroLevelCH1_Old + 11) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        // for delayed mode

        Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

    }
*/
	//----------------------------------
	// Draw Channel 1 Zero
	//----------------------------------

	//XY-Mode
	if ((Channel_1_Active) && (ZeroLevelCH1 > 0) && (ZeroLevelCH1 < 480) && (XY_Mode))
	{
		//DrawZeroSignXY(ZeroLevelCH1, 1);
		//ZeroLevelCH1_Old = ZeroLevelCH1;
	}

	//Main + Delayed Mode
    if ((Channel_1_Active) && (ZeroLevelCH1 > 0) && (ZeroLevelCH1 < (GRID_HEIGHT + 1)) && (XY_Mode == false) && FFT_Mode == FFT_OFF)
    {
        if (MenuStatus[10][1] == 1)	//Delayed Mode
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);

            Adr_Front_New_3 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Back_New_3 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Back_New_4 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);

            DrawZeroSign(bitbmCH1, Adr_Front_New_1);
            DrawZeroSign(bitbmCH1, Adr_Front_New_2);
            DrawZeroSign(bitbmCH1, Adr_Front_New_3);
            DrawZeroSign(bitbmCH1, Adr_Front_New_4);

            if (MenuStatus[1][0] == 6)
            {
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
            }
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane1 + ((ZeroLevelCH1 + 11) * 80);

            DrawZeroSign(bitbmCH1, Adr_Front_New_1);
            DrawZeroSign(bitbmCH1, Adr_Front_New_2);

            if (MenuStatus[1][0] == 6)
            {
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
            }
        }

        ZeroLevelCH1_Old = ZeroLevelCH1;
    }
    else if ((Channel_1_Active) && (ZeroLevelCH1 == 0) && (XY_Mode == false) && FFT_Mode == FFT_OFF)      // muß für xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (20 * 80);
            Adr_Front_New_3 = v_Channel_Plane1 + (213 * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (213 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);
            DrawZeroSign(bitbmMin, Adr_Front_New_3);
            DrawZeroSign(bitbmMin, Adr_Front_New_4);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (20 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
    }
    else if ((Channel_1_Active) && (ZeroLevelCH1 == (GRID_HEIGHT + 1)) && (XY_Mode == false)  && FFT_Mode == FFT_OFF)   // muß für xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (203 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (203 * 80);
            Adr_Front_New_3 = v_Channel_Plane1 + (396 * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);
            DrawZeroSign(bitbmMax, Adr_Front_New_3);
            DrawZeroSign(bitbmMax, Adr_Front_New_4);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (396 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
    }

    // Draw Trigger Channel 1
    //if ((triggering) && (Selected_Trigger_Source == 1))
    if ((Selected_Trigger_Source == 1) && (XY_Mode == false) && FFT_Mode == FFT_OFF)
    {
        if (MenuStatus[10][1] == 1)
        {
            if (MenuStatus[1][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane1 + (((Trigger_Pos_CH1 >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + (((Trigger_Pos_CH1 >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane1 + (((Trigger_Pos_CH1 >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane1 + (((Trigger_Pos_CH1 >> 1) + 206) * 80);
            }
            
            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
            }
        }
        else
        {
            if (MenuStatus[1][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) + 13) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane1 + ((Trigger_Pos_CH1 + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + ((Trigger_Pos_CH1 + 13) * 80);
            }
            
            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
            }
        }
        Trigger_Pos_CH1_Old = Trigger_Pos_CH1;
    }


	//------------------------------------------------------
	// Channel 2
	//------------------------------------------------------

/*BF del
    // Remove Trigger Channel 2
    //if (Selected_Trigger_Source_Old == 2)
    //{
        if (MenuStatus[2][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) + 13) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((Trigger_Pos_CH2_Old + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((Trigger_Pos_CH2_Old + 13) * 80);
        }
*/
/*BF test
        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
*/
        // for delayed mode
/* BF test
        if (MenuStatus[2][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 206) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 206) * 80);
        }
*/
/* BF test
        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSign(Adr_Front_Old_3);
        RemoveZeroSign(Adr_Front_Old_4);
*/

   // }

    // Remove Channel 2 Zero
  /*  if (XY_Mode)
    {
        Adr_Front_Old_1 = v_Channel_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Back_Old_1 = v_Channel_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (ZeroLevelCH2_Old + 1360);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);
    }
    else   
*/
/* BF test
    {
        if (XY_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        // for delayed mode

        Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11) * 80);


        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204) * 80);
        Adr_Back_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

    }
*/
    // Draw Channel 2 Zero
    if ((Channel_2_Active) && (ZeroLevelCH2 > 0) && (ZeroLevelCH2 < (GRID_HEIGHT + 1)) && FFT_Mode == FFT_OFF)
    {
        if (XY_Mode == false)    // nur zum ausblenden der zero bei XY
        {
        if (MenuStatus[10][1] == 1)
        {
            if (XY_Mode)
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
            }

            DrawZeroSign(bitbmCH2, Adr_Front_New_1);
            DrawZeroSign(bitbmCH2, Adr_Front_New_2);
            DrawZeroSign(bitbmCH2, Adr_Front_New_3);
            DrawZeroSign(bitbmCH2, Adr_Front_New_4);

            if (MenuStatus[2][0] == 6)
            {
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
            }
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane2 + ((ZeroLevelCH2 + 11) * 80);

            DrawZeroSign(bitbmCH2, Adr_Front_New_1);
            DrawZeroSign(bitbmCH2, Adr_Front_New_2);

            if (MenuStatus[2][0] == 6)
            {
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
            }
        }
        }

        ZeroLevelCH2_Old = ZeroLevelCH2;
    }
    else if ((Channel_2_Active) && (ZeroLevelCH2 == 0) && FFT_Mode == FFT_OFF )      // muß für xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (20 * 80);
            Adr_Front_New_3 = v_Channel_Plane2 + (213 * 80);
            Adr_Front_New_4 = v_Buffer_Plane2 + (213 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);
            DrawZeroSign(bitbmMin, Adr_Front_New_3);
            DrawZeroSign(bitbmMin, Adr_Front_New_4);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (20 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
    }
    else if ((Channel_2_Active) && (ZeroLevelCH2 == (GRID_HEIGHT + 1))  && FFT_Mode == FFT_OFF)   // muß für xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (203 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (203 * 80);
            Adr_Front_New_3 = v_Channel_Plane2 + (396 * 80);
            Adr_Front_New_4 = v_Buffer_Plane2 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);
            DrawZeroSign(bitbmMax, Adr_Front_New_3);
            DrawZeroSign(bitbmMax, Adr_Front_New_4);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (396 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
    }

    // Draw Trigger Channel 2
    //if ((triggering) && (Selected_Trigger_Source == 2))
    if ((Selected_Trigger_Source == 2) && (XY_Mode == false) && FFT_Mode == FFT_OFF)
    {
        if (MenuStatus[10][1] == 1)
        {
            if (MenuStatus[2][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((Trigger_Pos_CH2 >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((Trigger_Pos_CH2 >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane2 + (((Trigger_Pos_CH2 >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((Trigger_Pos_CH2 >> 1) + 206) * 80);
            }

            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
            }
        }
        else
        {
            if (MenuStatus[2][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) + 13) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + ((Trigger_Pos_CH2 + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + ((Trigger_Pos_CH2 + 13) * 80);
            }

            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
            }
        }
        Trigger_Pos_CH2_Old = Trigger_Pos_CH2;
    }


	//4 Channel version
    if (NumberOfChannels > 2)
    {
       
	//------------------------------------------------------
	// Channel 3
	//------------------------------------------------------

/* BF test
	 // Remove Trigger Channel 3
        //if (Selected_Trigger_Source_Old == 3)
        {
            if (MenuStatus[3][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) + 13) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + ((Trigger_Pos_CH3_Old + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + ((Trigger_Pos_CH3_Old + 13) * 80);
            }
*/
/* BF test
            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
*/
            // for delayed mode
/* BF test
            if (MenuStatus[3][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 206) * 80);
            }
*/
/*BF test
            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSign(Adr_Front_Old_3);
            RemoveZeroSign(Adr_Front_Old_4);
*/
       // }
/* BF test
        // Remove Channel 3 Zero
        if (XY_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Back_Old_1 = v_Channel_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (ZeroLevelCH3_Old + 1360);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane3 + ((ZeroLevelCH3_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + ((ZeroLevelCH3_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + ((ZeroLevelCH3_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + ((ZeroLevelCH3_Old + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);


            // for delayed mode

            Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

        }
*/
        // Draw Channel 3 Zero
        if (!XY_Mode && Channel_3_Active && (ZeroLevelCH3 > 0) && (ZeroLevelCH3 < (GRID_HEIGHT + 1)) && FFT_Mode == FFT_OFF)
//BF del	if (Channel_3_Active && (ZeroLevelCH3 > 0) && (ZeroLevelCH3 < (GRID_HEIGHT + 1)))
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);

                DrawZeroSign(bitbmCH3, Adr_Front_New_1);
                DrawZeroSign(bitbmCH3, Adr_Front_New_2);
                DrawZeroSign(bitbmCH3, Adr_Front_New_3);
                DrawZeroSign(bitbmCH3, Adr_Front_New_4);

                if (MenuStatus[3][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
                }
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane3 + ((ZeroLevelCH3 + 11) * 80);

                DrawZeroSign(bitbmCH3, Adr_Front_New_1);
                DrawZeroSign(bitbmCH3, Adr_Front_New_2);

                if (MenuStatus[3][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                }
            }

            ZeroLevelCH3_Old = ZeroLevelCH3;
        }
        else if ((Channel_3_Active) && (ZeroLevelCH3 == 0) && FFT_Mode == FFT_OFF)      // muß für xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (20 * 80);
                Adr_Front_New_3 = v_Channel_Plane3 + (213 * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (213 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);
                DrawZeroSign(bitbmMin, Adr_Front_New_3);
                DrawZeroSign(bitbmMin, Adr_Front_New_4);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (20 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
        }
        else if ((Channel_3_Active) && (ZeroLevelCH3 == (GRID_HEIGHT + 1)) && FFT_Mode == FFT_OFF)   // muß für xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (203 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (203 * 80);
                Adr_Front_New_3 = v_Channel_Plane3 + (396 * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);
                DrawZeroSign(bitbmMax, Adr_Front_New_3);
                DrawZeroSign(bitbmMax, Adr_Front_New_4);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (396 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
        }


        // Draw Trigger Channel 3
        //if ((triggering) && (Selected_Trigger_Source == 3))
        if ((Selected_Trigger_Source == 3) && (XY_Mode == false) && FFT_Mode == FFT_OFF)
        {
            if (MenuStatus[10][1] == 1)
            {
                if (MenuStatus[3][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 206) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + (((Trigger_Pos_CH3 >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + (((Trigger_Pos_CH3 >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane3 + (((Trigger_Pos_CH3 >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane3 + (((Trigger_Pos_CH3 >> 1) + 206) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
                }
            }
            else
            {
                if (MenuStatus[3][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) + 13) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + ((Trigger_Pos_CH3 + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + ((Trigger_Pos_CH3 + 13) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                }
            }
            Trigger_Pos_CH3_Old = Trigger_Pos_CH3;
        }


	//------------------------------------------------------
	// Channel 4
	//------------------------------------------------------
/* BF test
        // Remove Trigger Channel 4
        //if (Selected_Trigger_Source_Old == 4)
        {
            if (MenuStatus[4][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) + 13) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + ((Trigger_Pos_CH4_Old + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + ((Trigger_Pos_CH4_Old + 13) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);

            // for delayed mode

            if (MenuStatus[4][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 206) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSign(Adr_Front_Old_3);
            RemoveZeroSign(Adr_Front_Old_4);

        }

        // Remove Channel 4 Zero
        if (XY_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Back_Old_1 = v_Channel_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (ZeroLevelCH4_Old + 1360);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane4 + ((ZeroLevelCH4_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + ((ZeroLevelCH4_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + ((ZeroLevelCH4_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + ((ZeroLevelCH4_Old + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);


            // for delayed mode

            Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

        }
*/
        // Draw Channel 4 Zero
	 if (!XY_Mode && Channel_4_Active && (ZeroLevelCH4 > 0) && (ZeroLevelCH4 < (GRID_HEIGHT + 1)) && FFT_Mode == FFT_OFF)
//BF del        if ((Channel_4_Active) && (ZeroLevelCH4 > 0) && (ZeroLevelCH4 < (GRID_HEIGHT + 1)))
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);

                DrawZeroSign(bitbmCH4, Adr_Front_New_1);
                DrawZeroSign(bitbmCH4, Adr_Front_New_2);
                DrawZeroSign(bitbmCH4, Adr_Front_New_3);
                DrawZeroSign(bitbmCH4, Adr_Front_New_4);

                if (MenuStatus[4][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
                }
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane4 + ((ZeroLevelCH4 + 11) * 80);

                DrawZeroSign(bitbmCH4, Adr_Front_New_1);
                DrawZeroSign(bitbmCH4, Adr_Front_New_2);

                if (MenuStatus[4][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                }
            }

            ZeroLevelCH4_Old = ZeroLevelCH4;
        }
        else if ((Channel_4_Active) && (ZeroLevelCH4 == 0) && FFT_Mode == FFT_OFF)      // muß für xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (20 * 80);
                Adr_Front_New_3 = v_Channel_Plane4 + (213 * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (213 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);
                DrawZeroSign(bitbmMin, Adr_Front_New_3);
                DrawZeroSign(bitbmMin, Adr_Front_New_4);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (20 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
        }
        else if ((Channel_4_Active) && (ZeroLevelCH4 == (GRID_HEIGHT + 1)) && FFT_Mode == FFT_OFF)   // muß für xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (203 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (203 * 80);
                Adr_Front_New_3 = v_Channel_Plane4 + (396 * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);
                DrawZeroSign(bitbmMax, Adr_Front_New_3);
                DrawZeroSign(bitbmMax, Adr_Front_New_4);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (396 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
        }

        // Draw Trigger Channel 4
        //if ((triggering) && (Selected_Trigger_Source == 4))
        if ((Selected_Trigger_Source == 4) && (XY_Mode == false) && FFT_Mode == FFT_OFF)
        {
            if (MenuStatus[10][1] == 1)
            {
                if (MenuStatus[4][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 206) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + (((Trigger_Pos_CH4 >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + (((Trigger_Pos_CH4 >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane4 + (((Trigger_Pos_CH4 >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane4 + (((Trigger_Pos_CH4 >> 1) + 206) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
                }
            }
            else
            {
                if (MenuStatus[4][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) + 13) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + ((Trigger_Pos_CH4 + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + ((Trigger_Pos_CH4 + 13) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                }
            }
            Trigger_Pos_CH4_Old = Trigger_Pos_CH4;
        }
    }

    if (ZeroLevelCH1 < 5) TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//    if (ZeroLevelCH1 < 5) TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text
}
